<template>
  <div class="container">
    <div class="text-right">
      <b-button variant="danger" @click="logout" class="my-3">Log out</b-button>
    </div>
    <form @submit.prevent="updateUserInfo">
      <b-row class="my-1">
        <b-col sm="3">
          <label for="name">Name:</label>
        </b-col>
        <b-col sm="9">
          <b-form-input id="name" v-model="user.username" type="text" required></b-form-input>
        </b-col>
      </b-row>

      <b-row class="my-1">
        <b-col sm="3">
          <label for="email">Email:</label>
        </b-col>
        <b-col sm="9">
          <b-form-input id="email" v-model="user.email" type="email" required ></b-form-input>
        </b-col>
      </b-row>

      <b-row class="my-1">
        <b-col sm="3">
          <label for="password_old">Password:</label>
        </b-col>
        <b-col sm="9">
          <b-form-input id="password_old" v-model="user.password" type="password" required></b-form-input>
        </b-col>
      </b-row>

      <b-row class="my-1">
        <b-col sm="3">
          <label for="password">New Password:</label>
        </b-col>
        <b-col sm="9">
          <b-form-input id="password" v-model="user.new_pass" type="password" required></b-form-input>
        </b-col>
      </b-row>
    
        <b-row class="my-1">
        <b-col sm="3">
          <label for="city">State:</label>
        </b-col>
        <b-col sm="9">
          <b-form-select id="state" v-model="user.state" @change="getCity">
             <option  v-for="item in region" :value="item.id" :key="item.id" >{{ item.name }}</option>
          </b-form-select>
        </b-col>
      </b-row>

      <b-row class="my-1">
        <b-col sm="3">
          <label for="city">City:</label>
        </b-col>
        <b-col sm="9">
          <b-form-select  v-if="city" id="city" v-model="user.city">
            <option  v-for="item in city" :value="item._id" :key="item._id" >{{ item.name }}</option>
          </b-form-select>
          <b-form-select v-else disabled>
          </b-form-select>
        </b-col>
      </b-row>

   
      <b-button type="submit">Save</b-button>
    </form>
    <b-alert variant="success" v-if="success" class="my-3" show>{{ success }}</b-alert>
       <b-alert variant="danger" v-if="errors" class="my-3" show>{{ errors }}</b-alert>
    <!-- <Users/> -->
  </div>
</template>

<script>
export default {
  name: "Home",
  data() {
    return {
      errors: null,
      success: '',
      user: {
        username: "",
        email: "",
        new_pass: "",
        password: "",
        city: "",
        state: ""
      },
      region: '',
      city: '',
      name: this.$store.state.user.username
    };
  },
  methods: {
    logout: async function() {
      try {
        await this.$http.get("/api/auth/logout");
        this.$store.dispatch("logout");
        this.$router.push("/");
      } catch (err) {
        this.errors = err.body;
      }
    },
    getUserInfo: async function() {
      try {
        const res = (await this.$http.post("/api/user/getUserInfo", {
          name: this.name
        })).body;
        this.user = res.user;
        this.$store.dispatch("setUserInfo",res.user);
      } catch (error) {
        this.errors = error.body;
      }
    },
    updateUserInfo: async function() {
       this.success = "";
      try {
         (await this.$http.post("/api/user/updateUserInfo", { name: this.name , user: this.user }));
          this.success = "Ваш профиль обновлен";
          this.errors = '';
           this.name = this.user.username;
           this.getUserInfo();
      } catch (error) {
        this.errors = error.body;
      }
      
    },
    getState: async function() {
      try {
        const res = (await this.$http.post("/api/user/getState",{})).body;
        this.region = res.data;
          if(this.user.city) {
            this.getCity();
          }
      } catch (error) {
        this.errors = error.body;
      }
    },
    getCity: async function () {
        try {
        const res = (await this.$http.post("/api/user/getCity",{id: this.user.state})).body;
        this.city = res.data;
      } catch (error) {
        this.errors = error.body;
      }
    }
  },
  beforeMount() {
    this.getUserInfo();
    this.getState();   
  }
};
</script>
<style scoped>
</style>
